'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _ContentContainer = require('../ContentContainer');

var _ContentContainer2 = _interopRequireDefault(_ContentContainer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
  image: {
    display: 'block',
    maxWidth: '100%'
  }
};

var View = function (_React$Component) {
  _inherits(View, _React$Component);

  function View() {
    _classCallCheck(this, View);

    return _possibleConstructorReturn(this, (View.__proto__ || Object.getPrototypeOf(View)).apply(this, arguments));
  }

  _createClass(View, [{
    key: 'getUploadPreview',
    value: function getUploadPreview() {
      var uploads = this.context.flatpack.store.getState().content.uploads;

      var upload = uploads[this.props.path];

      if (upload) {
        console.log('Getting upload preview', upload.preview.length);
        return upload.preview;
      }
    }
  }, {
    key: 'getImageProps',
    value: function getImageProps() {
      var _props$value = this.props.value,
          path = _props$value.path,
          variations = _props$value.variations;

      var preview = this.getUploadPreview();

      if (preview) {
        return { src: preview };
      }

      if (variations) {
        return {
          src: path + '/' + (0, _lodash.first)(variations).width,
          srcSet: (0, _lodash.map)(variations, function (variation) {
            return path + '/' + variation.width + ' ' + variation.width + 'w';
          }).join(', ')
        };
      }

      if (path) {
        return {
          src: path
        };
      }
    }
  }, {
    key: 'hasImage',
    value: function hasImage() {
      return this.props.value || this.getUploadPreview();
    }
  }, {
    key: 'render',
    value: function render() {
      if (!this.hasImage()) {
        return null;
      }

      var style = _extends({}, styles.image, this.props.style);

      return _react2.default.createElement('img', _extends({ style: style }, this.getImageProps()));
    }
  }]);

  return View;
}(_react2.default.Component);

View.propTypes = {
  path: _react2.default.PropTypes.string.isRequired,
  value: _react2.default.PropTypes.object,
  style: _react2.default.PropTypes.object
};
View.defaultProps = {
  value: {}
};
View.contextTypes = {
  flatpack: _react2.default.PropTypes.object
};
exports.default = (0, _ContentContainer2.default)(View);