'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.serialize = serialize;
exports.deserialize = deserialize;

var _lodash = require('lodash');

// Serialized (stored) state:
// { _order: ['a', 'b'], a: {}, b: {}}
function serialize(value) {
  var order = (0, _lodash.map)(value, function (_ref) {
    var key = _ref.key;
    return key;
  });
  var items = (0, _lodash.mapValues)((0, _lodash.keyBy)(value, 'key'), 'item');

  return _extends({
    _order: order
  }, items);
}

// Deserialized (internal) state:
// [{ key: 'a', value: {}}, { key: 'b', value: {}}]
function deserialize(value) {
  var onlyItems = (0, _lodash.omit)(value, '_order');
  var items = (0, _lodash.map)(onlyItems, function (item, key) {
    return { key: key, item: item };
  });

  return (0, _lodash.sortBy)(items, function (_ref2) {
    var item = _ref2.item,
        key = _ref2.key;
    return (0, _lodash.indexOf)(value._order, key);
  });
}