'use strict';

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var path = require('path');
var fs = require('fs');

var _require = require('lodash'),
    assignWith = _require.assignWith,
    isUndefined = _require.isUndefined,
    isPlainObject = _require.isPlainObject,
    isArray = _require.isArray;

var merge = function merge() {
  for (var _len = arguments.length, objs = Array(_len), _key = 0; _key < _len; _key++) {
    objs[_key] = arguments[_key];
  }

  return assignWith.apply(undefined, [{}].concat(objs, [function (objValue, srcValue) {
    return isPlainObject(objValue) && isPlainObject(srcValue) ? merge(srcValue, objValue) : isArray(objValue) && isArray(srcValue) ? [].concat(_toConsumableArray(srcValue), _toConsumableArray(objValue)) : isUndefined(objValue) ? srcValue : objValue;
  }]));
};

module.exports = function getWebpackConfig(environment) {
  var baseConfig = require('./webpack.' + environment + '.config.js');
  var projectConfigPath = path.resolve(process.cwd(), 'webpack.config.js');

  var transform = function transform(config) {
    return config;
  };

  if (fs.existsSync(projectConfigPath)) {
    var projectConfig = require(projectConfigPath);

    projectConfig = projectConfig.default || projectConfig;

    if (isPlainObject(projectConfig)) {
      transform = function transform(config) {
        return merge(config, projectConfig);
      };
    } else if (typeof projectConfig === 'function') {
      transform = projectConfig;
    }
  }

  return transform(baseConfig);
};