'use strict';

var express = require('express');
var chalk = require('chalk');
var openport = require('openport');

var build = require('./middleware/build');
var upload = require('./middleware/upload');
var config = require('./middleware/config');
var serve = require('./middleware/serve');
var error = require('./middleware/error');

module.exports = function createServer() {
  var app = express();

  app.post('/build', build);
  app.use('/uploads', upload);
  app.use(config);
  app.use(serve);
  app.use(error);

  openport.find({
    startingPort: 3000,
    endingPort: 4000
  }, function (err, port) {
    if (err) {
      return console.log(err);
    }

    app.listen(3000, function () {
      console.log('✨ Server listening at: ' + chalk.underline(chalk.bold('http://localhost:' + port)));
    });
  });
};